import request from '@/utils/request'

// 登录方法
export function login(username, password, code, uuid,tenantId,clientId,grantType) {
  const data = {
    username,
    password,
    code,
    uuid,
	tenantId,
	clientId,
	grantType
  }
  return request({
    'url': '/auth/login',
    headers: {
      isToken: false
    },
    'method': 'post',
    'data': data
  })
}
// 解码接口
export function getweChatOpenid(data) {
  return request({
    'url': '/weChatOpenid',
    'method': 'post',
	'data':data
  })
}
// 微信登录
export function getweChatLogin(data) {
  return request({
    'url': '/auth/weChatLogin',
    'method': 'post',
	'data':data
  })
}
// 获取用户详细信息
export function getInfo() {
  return request({
    'url': '/system/user/getInfo',
    'method': 'get'
  })
}
// 获取用户详细信息
export function gettenantList() {
  return request({
    'url': '/auth/tenant/list',
    'method': 'get'
  })
}
// 获取注册学校详细信息
export function getschoolList(data) {
  return request({
    'url': '/auth/school/list',
    'method': 'get',
	'data':data
  })
}
// 退出方法
export function logout() {
  return request({
    'url': '/auth/logout',
    'method': 'post'
  })
}

// 获取验证码
export function getCodeImg() {
  return request({
    'url': '/auth/code',
    headers: {
      isToken: false
    },
    method: 'get',
    timeout: 20000
  })
}
